9-001 // Sugarscape in Swarm. Copyright  1997-1998 Nelson Minar
9-002 // This program is distributed without any warranty; without even the
9-003 // implied warranty of merchantability or fitness for a particular purpose.
9-004 // See file LICENSE for details and terms of copying.
9-005 
9-006 #import <simtoolsgui.h>
9-007 #import <simtoolsgui/GUISwarm.h>
9-008 #import <analysis.h> // EZGraph
9-009 #import <space.h> // Value2dDisplay, Object2dDisplay
9-010 #import "ModelSwarm.h"
9-011 
9-012 // The observer swarm contains all the objects used to instrument a model
9-013 @interface ObserverSwarm: GUISwarm
9-014 {
9-015   ModelSwarm *modelSwarm;			  // the model being run
9-016 
9-017   char * parameterFile;
9-018   int displayFrequency;				  // how often to update
9-019   int drawPopulationGraph;			  // flag
9-020   int drawWealthHistogram;			  // flag
9-021 
9-022   id <Colormap> colormap;			  // colours
9-023   id <ZoomRaster> worldRaster;			  // window on world
9-024   id <Value2dDisplay> sugarDisplay;		  // sugar displayer
9-025   id <Object2dDisplay> agentDisplay;		  // agent displayer
9-026   id <EZGraph> populationGraph;			  // population graph
9-027   id <EZGraph> attributeGraph;			  // agent attributes graph
9-028   id <EZBin> wealthHistogram;			  // histogram of wealth
9-029 
9-030   id displayActions;				  // schedule objects
9-031   id displaySchedule;
9-032 }
9-033 
9-034 + createBegin: aZone;
9-035 - buildObjects;
9-036 
9-037 - (char*)setParameterFile: (char*)aString;
9-038 - saveParameters: (char*)aString;
9-039 
9-040 - buildActions;
9-041 - activateIn: swarmContext;
9-042 
9-043 @end

